package com.hzya.frame.mdm.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.mdm.mdmModule.dao.IMdmModuleDao;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModuleDb.dao.IMdmModuleDbDao;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.dao.IMdmModuleDbFiledsDao;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.IMdmModuleDbFiledsRuleDao;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity;
import com.hzya.frame.mdm.mdmModuleDistribute.dao.IMdmModuleDistributeDao;
import com.hzya.frame.mdm.mdmModuleDistributeDetail.dao.IMdmModuleDistributeDetailDao;
import com.hzya.frame.mdm.mdmModuleView.dao.IMdmModuleViewDao;
import com.hzya.frame.mdm.mdmModuleView.entity.MdmModuleViewEntity;
import com.hzya.frame.mdm.mdmModuleViewButton.dao.IMdmModuleViewButtonDao;
import com.hzya.frame.mdm.mdmModuleViewButton.entity.MdmModuleViewButtonEntity;
import com.hzya.frame.mdm.mdmModuleViewDetail.dao.IMdmModuleViewDetailDao;
import com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity;
import com.hzya.frame.mdm.mdmTableCodeRule.dao.IMdmTableCodeRuleDao;
import com.hzya.frame.mdm.mdmTableCodeRule.entity.MdmTableCodeRuleEntity;
import com.hzya.frame.mdm.service.IMdmService;
import com.hzya.frame.mdm.service.IMdmServiceCache;
import com.hzya.frame.sysnew.integtationTask.entity.IntegrationTaskEntity;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;


/**
 * 主数据服务实现类
 */
@Service(value = "mdmServiceCache")
public class MdmServiceCache implements IMdmServiceCache {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());
    @Resource
    private IMdmModuleDao mdmModuleDao;
    @Resource
    private IMdmModuleDbDao mdmModuleDbDao;
    @Resource
    private IMdmModuleDbFiledsDao mdmModuleDbFiledsDao;
    @Resource
    private IMdmModuleDbFiledsRuleDao mdmModuleDbFiledsRuleDao;
    @Resource
    private IMdmModuleDistributeDao mdmModuleDistributeDao;
    @Resource
    private IMdmModuleDistributeDetailDao mdmModuleDistributeDetailDao;
    @Resource
    private IMdmModuleViewDao mdmModuleViewDao;
    @Resource
    private IMdmModuleViewButtonDao mdmModuleViewButtonDao;
    @Resource
    private IMdmModuleViewDetailDao mdmModuleViewDetailDao;
    @Resource
    private IMdmTableCodeRuleDao mdmTableCodeRuleDao;

    @Override
    @Cacheable(cacheNames="mdmModule",key = "#mdmCode")
    public MdmModuleEntity getMdmModuleEntity(Long mdmCode) {
        MdmModuleEntity entity = mdmModuleDao.getByMdmCode(mdmCode);
        return entity;
    }

    @Override
    @CacheEvict(cacheNames="mdmModule",key = "#entity.mdmCode")
    public void updateMdmModuleEntity(MdmModuleEntity entity) {
        mdmModuleDao.update(entity);
    }

    @Override
    @Cacheable(cacheNames="mdmTableCodeRule",key = "#mdmId")
    public List<MdmTableCodeRuleEntity> queryMdmTableCodeRuleEntity(MdmTableCodeRuleEntity entity) {
        List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntityList = mdmTableCodeRuleDao.queryBase(entity);
        return mdmTableCodeRuleEntityList;
    }


    @Override
    @Cacheable(cacheNames="mdmModuleDb",key = "#mdmId")
    public List<MdmModuleDbEntity> queryMdmModuleDb(MdmModuleDbEntity entity) {
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmModuleDbDao.queryBase(entity);
        return mdmModuleDbEntities;
    }

    @Override
    @Cacheable(cacheNames="mdmModuleDbFileds",key = "#mdmId")
    public List<MdmModuleDbFiledsEntity> queryMdmModuleDbFileds(MdmModuleDbFiledsEntity entity) {
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities = mdmModuleDbFiledsDao.queryBase(entity);
        return mdmModuleDbFiledsEntities;
    }

    @Override
    @Cacheable(cacheNames="mdmModuleDbFiledsRule",key = "#mdmId")
    public List<MdmModuleDbFiledsRuleEntity> queryMdmModuleDbFiledsRule(MdmModuleDbFiledsRuleEntity entity) {
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities = mdmModuleDbFiledsRuleDao.queryBase(entity);
        return mdmModuleDbFiledsRuleEntities;
    }

    @Override
    @CacheEvict(cacheNames="mdmTableCodeRule",key = "#mdmId")
    public void saveMdmTableCodeRule(String mdmId, List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntities) {
        MdmTableCodeRuleEntity mdmTableCodeRuleEntity = new MdmTableCodeRuleEntity();
        mdmTableCodeRuleEntity.setMdmId(mdmId);
        mdmTableCodeRuleEntity.setSts("Y");
        mdmTableCodeRuleEntity.setUpdate();
        mdmTableCodeRuleDao.logicRemoveMultiCondition(mdmTableCodeRuleEntity);
        if(mdmTableCodeRuleEntities != null && mdmTableCodeRuleEntities.size() > 0){
            for (int i = 0; i < mdmTableCodeRuleEntities.size(); i++) {
                mdmTableCodeRuleDao.save(mdmTableCodeRuleEntities.get(i));
            }
        }
    }

    @Override
    @CacheEvict(cacheNames="mdmModuleDb",key = "#mdmId")
    public void saveMdmModuleDb(String mdmId, List<MdmModuleDbEntity> mdmModuleDbEntities) {
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDataType())){
                    mdmModuleDbDao.save(mdmModuleDbEntities.get(i));
                }else {
                    mdmModuleDbDao.update(mdmModuleDbEntities.get(i));
                }
            }
        }
    }
    @Override
    @CacheEvict(cacheNames="mdmModuleDbFileds",key = "#mdmId")
    public void saveMdmModuleDbFileds(String mdmId, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities) {
        if(mdmModuleDbFiledsEntities != null && mdmModuleDbFiledsEntities.size() > 0){
            for (int i = 0; i < mdmModuleDbFiledsEntities.size(); i++) {
                if("1".equals(mdmModuleDbFiledsEntities.get(i).getDataType())){
                    mdmModuleDbFiledsDao.save(mdmModuleDbFiledsEntities.get(i));
                }else {
                    mdmModuleDbFiledsDao.update(mdmModuleDbFiledsEntities.get(i));
                }
            }
        }
    }
    @Override
    @CacheEvict(cacheNames="mdmModuleDbFiledsRule",key = "#mdmId")
    public void saveMdmModuleDbFiledsRule(String mdmId, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities) {
        MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = new MdmModuleDbFiledsRuleEntity();
        mdmModuleDbFiledsRuleEntity.setMdmId(mdmId);
        mdmModuleDbFiledsRuleEntity.setSts("Y");
        mdmModuleDbFiledsRuleEntity.setUpdate();
        mdmModuleDbFiledsRuleDao.logicRemoveMultiCondition(mdmModuleDbFiledsRuleEntity);
        if(mdmModuleDbFiledsRuleEntities != null && mdmModuleDbFiledsRuleEntities.size() > 0){
            for (int i = 0; i < mdmModuleDbFiledsRuleEntities.size(); i++) {
                if("1".equals(mdmModuleDbFiledsRuleEntities.get(i).getDataType())){
                    mdmModuleDbFiledsRuleDao.save(mdmModuleDbFiledsRuleEntities.get(i));
                }else {
                    mdmModuleDbFiledsRuleDao.update(mdmModuleDbFiledsRuleEntities.get(i));
                }
            }
        }
    }

    @Override
    @Cacheable(cacheNames="mdmModuleViewDetail",key = "#mdmId")
    public List<MdmModuleViewDetailEntity> queryMdmModuleViewDetail(MdmModuleViewDetailEntity mdmModuleViewDetailEntity) {
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities = mdmModuleViewDetailDao.queryBase(mdmModuleViewDetailEntity);
        return mdmModuleViewDetailEntities;
    }

    @Override
    @Cacheable(cacheNames="mdmModuleView",key = "#mdmId")
    public List<MdmModuleViewEntity> queryMdmModuleView(MdmModuleViewEntity mdmModuleViewEntity) {
        List<MdmModuleViewEntity> moduleViewEntities = mdmModuleViewDao.queryBase(mdmModuleViewEntity);
        return moduleViewEntities;
    }

    @Override
    @Cacheable(cacheNames="mdmModuleViewButton",key = "#mdmId")
    public List<MdmModuleViewButtonEntity> queryMdmModuleViewButton(MdmModuleViewButtonEntity mdmModuleViewButtonEntity) {
        List<MdmModuleViewButtonEntity> mdmModuleViewButtonEntities = mdmModuleViewButtonDao.queryBase(mdmModuleViewButtonEntity);
        return mdmModuleViewButtonEntities;
    }

    @Override
    @CacheEvict(cacheNames="mdmModuleView",key = "#mdmId")
    public void saveMdmModuleView(String mdmId, MdmModuleViewEntity mdmModuleViewEntity) {
        mdmModuleViewDao.update(mdmModuleViewEntity);
    }

    @Override
    @CacheEvict(cacheNames="mdmModuleViewDetail",key = "#mdmId")
    public void saveMdmModuleViewDetail(String mdmId, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities) {
        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmId);
        mdmModuleViewDetailEntity.setUpdate();
        mdmModuleViewDetailDao.logicRemoveMultiCondition(mdmModuleViewDetailEntity);
        if(mdmModuleViewDetailEntities != null && mdmModuleViewDetailEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewDetailEntities.size(); i++) {
                if("1".equals(mdmModuleViewDetailEntities.get(i).getDataType())){
                    mdmModuleViewDetailDao.save(mdmModuleViewDetailEntities.get(i));
                }else {
                    mdmModuleViewDetailDao.update(mdmModuleViewDetailEntities.get(i));
                }
            }
        }
    }

    @Override
    @CacheEvict(cacheNames="mdmModuleViewButton",key = "#mdmId")
    public void saveMdmModuleViewButton(String mdmId, List<MdmModuleViewButtonEntity> mdmModuleViewButtonEntities) {
        MdmModuleViewButtonEntity mdmModuleViewButtonEntity = new MdmModuleViewButtonEntity();
        mdmModuleViewButtonEntity.setMdmId(mdmId);
        mdmModuleViewButtonEntity.setUpdate();
        mdmModuleViewButtonDao.logicRemoveMultiCondition(mdmModuleViewButtonEntity);
        if(mdmModuleViewButtonEntities != null && mdmModuleViewButtonEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewButtonEntities.size(); i++) {
                if("1".equals(mdmModuleViewButtonEntities.get(i).getDataType())){
                    mdmModuleViewButtonDao.save(mdmModuleViewButtonEntities.get(i));
                }else {
                    mdmModuleViewButtonDao.update(mdmModuleViewButtonEntities.get(i));
                }
            }
        }
    }

}
