package com.hzya.frame.sys.dataSource.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sys.dataSource.entity.SysDataSourceEntity;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.web.entity.JsonResultEntity;

/**
 * 数据源表(SysDataSource)表服务接口
 *
 * @author makejava
 * @since 2023-09-05 16:07:10
 */
public interface ISysDataSourceService extends IBaseService<SysDataSourceEntity, String>{
    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询列表
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity queryList(JSONObject jsonObject);
    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询列表
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity queryPage(JSONObject jsonObject);
    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 获取数据
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity queryEntity(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 新增数据
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity addEntity(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 修改数据
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity editEntity(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 删除数据
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity deleteEntity(JSONObject jsonObject);
    /**
     * @Author lvleigang
     * @Description  数据源测试接口 测试当前页面数据源是否配置正确
     * @Date 2:08 下午 2023/9/23
     * @param jsonObject
     * @return
     **/
    JsonResultEntity testDatabase(JSONObject jsonObject);
}
